<?php

/*

Conexión de API a base de datos de Proyecto Raíces: Inventario.php
- Autor:            Miguel E. Cruz Molina
- # de estudiante:  801-16-1956
- Curso y sección:  CCOM 4027-002
- Intructor:        Prof. Carlos J. Corrada Bravo
- Fecha de última edición: 10/04/2021

Resumen: Este archivo de PHP implementa la clase "Inventario",
   que establece un pedido de SQL para extraer los datos del
   inventario de la tienda de Raíces (IDs y nombres de productos
   y de sus vendedores, así como fotos representativas para cada
   producto), y un método "read()" para ejecutar dicho pedido
   y extraer esos datos de forma tabulada.

*/

    class Inventario {

    private $conn;

    public $id_producto;
    public $nom_producto;
    public $id_comerciante;
    public $nom_comerciante;

    // Constructor:

    public function __construct($database) {
      $this->conn = $database;
    }

    // Obtener nombres de productos y comerciantes:

    public function read() {
      $query = 'SELECT P.nom_producto, P.id_producto,
                       C.id_comerciante, C.nom_comerciante
                FROM comerciantes C, vende V, productos P
                WHERE P.id_producto = V.id_producto
                  AND V.id_comerciante = C.id_comerciante';

      // Statement:

      $statement = $this->conn->prepare($query);

      $statement->execute();

      return $statement;
    }

    // Buscar imagen correspondiente a cada producto:

    public function imagen($id_producto) {
      $query = "SELECT D.imagen_chunk1, D.imagen_chunk2
                FROM productos P, disenos D
                WHERE P.id_producto = $id_producto
                  AND P.id_default_diseno = D.id_diseno";

      // Statement:

      $statement = $this->conn->prepare($query);

      $statement->execute();

      return $statement;
    }

    // Buscar precio correspondiente de cada producto:

    public function precio($id_producto) {
      $query = "SELECT I.precio
                FROM productos P, inventario I
                WHERE P.id_producto = $id_producto
                  AND P.id_default_inventario = I.id_inventario";

      // Statement:

      $statement = $this->conn->prepare($query);

      $statement->execute();

      return $statement;
    }

    // Buscar insignias correspondientes a cada comerciante/producto:

    public function insignias($comerciante) {
      $query = "SELECT I.id_insignia
                FROM comerciante_es C, insignias_coms I
                WHERE C.id_comerciante = $comerciante
                  AND C.id_insignia = I.id_insignia";

      // Statement:

      $statement = $this->conn->prepare($query);

      $statement->execute();

      return $statement;
    }
  }
?>
