<?php

/*

Conexión de API a base de datos de Proyecto Raíces: Producto.php
- Autor:            Miguel E. Cruz Molina
- # de estudiante:  801-16-1956
- Curso y sección:  CCOM 4027-002
- Intructor:        Prof. Carlos J. Corrada Bravo
- Fecha de última edición: 10/04/2021

Resumen: Este archivo de PHP implementa la clase "Producto",
   que establece un pedido de SQL para extraer los datos necesarios
   para generar la página particular de un producto seleccionado en
   la tienda de Raíces (nombre, comerciante, tamaños, diseños, precios,
   cantidades, fotos, etc.), además de un método "read()" que, dado el
   identificador del producto, ejecuta dicho pedido y extrae esos datos
   de forma tabulada.

*/

    class Producto {

    private $conn;
    private $id_producto;

    public $nom_producto;
    public $id_comerciante;
    public $nom_comerciante;
    public $precio;
    public $cantidad;
    public $id_diseno;
    public $diseno;
    public $id_inventorio;
    public $tamano;

    public $imagen_chunk1;
    public $imagen_chunk2;

    // Constructor:

    public function __construct($database, $id) {
      $this->conn = $database;
      $this->id_producto = intval($id);
    }

    // Obtener información básica del producto:

    public function maindata() {

      $query = "SELECT DISTINCT P.nom_producto, C.id_comerciante,
                  C.nom_comerciante, I.precio, I.cantidad,
                  P.id_default_diseno, P.id_default_inventario
                FROM comerciantes C, vende V, productos P, inventario I
                WHERE P.id_producto = $this->id_producto
                  AND P.id_producto = V.id_producto
                  AND V.id_comerciante = C.id_comerciante
                  AND P.id_default_inventario = I.id_inventario";

      // Statement:

      $statement = $this->conn->prepare($query);

      $statement->execute();

      return $statement;
    }

    // Obtener datos de diseños del producto:

    public function designdata() {
      $query = "SELECT id_diseno, diseno,
                imagen_chunk1, imagen_chunk2
                FROM disenos
                WHERE id_producto = $this->id_producto";

      // Statement:

      $statement = $this->conn->prepare($query);

      $statement->execute();

      return $statement;
    }

    // Obtener datos del producto en el inventorio:

    public function inventorydata() {
      $query = "SELECT id_inventario, tamano,
                  precio, cantidad
                FROM inventario
                WHERE id_producto = $this->id_producto";

      // NOTA: INCLUIR FOTOS Y CANTIDAD POR INVENTORIO

      // Statement:

      $statement = $this->conn->prepare($query);

      $statement->execute();

      return $statement;
    }

    //  Obtener atos de las insignias del producto:

    public function insigniasdata() {
      $query = "SELECT I.id_insignia, I.nom_insignia
                FROM producto_es P, insignias_prods I
                WHERE P.id_producto = $this->id_producto
                  AND P.id_insignia = I.id_insignia";

      // NOTA: INCLUIR FOTOS DE INSIGNIAS

      // Statement:

      $statement = $this->conn->prepare($query);

      $statement->execute();

      return $statement;
    }

  }
?>
